var fileMenuTemplate = GC.Spread.Sheets.Designer.getTemplate(
    GC.Spread.Sheets.Designer.TemplateNames.FileMenuPanelTemplate
);
addCustomItem(fileMenuTemplate);

GC.Spread.Sheets.Designer.registerTemplate(
    GC.Spread.Sheets.Designer.TemplateNames.FileMenuPanelTemplate,
    fileMenuTemplate
);


function addCustomItem(template) {
    var listContainer =
        template["content"][0]["children"][0]["children"][0]["children"][0][
        "children"
        ][1];
    listContainer.items.push({ text: "Custom Actions", value: "CustomItem" });

    var listDisplayContainer = template["content"][0]["children"][0]["children"][1];
    listDisplayContainer.children.push({
        type: "Container",
        visibleWhen: "activeCategory_main=CustomItem",
        children: [
            {
                type: "TextBlock",
                margin: "50px 0 15px 50px",
                text: "Custom Actions",
                style: "font-size:36px;line-height:80px"
            },
            {
                type: "ColumnSet",
                margin: "0 0 0 50px",
                children: [
                    {
                        type: "Column",
                        children: [
                            {
                                type: "List",
                                className: "file-menu-list",
                                items: [
                                    {
                                        text: "Print",
                                        value: "print"
                                    },
                                    {
                                        text: "Action 1",
                                        value: "action_1"
                                    },
                                    {
                                        text: "Action 2",
                                        value: "action_2"
                                    }
                                ],
                                bindingPath: "custom_item"
                            }
                        ],
                        width: "350px"
                    },
                    {
                        type: 'Container',
                        children: [
                            {
                                "type": "Button",
                                "margin": "20px 50px",
                                "text": "Printing",
                                "width": 120,
                                "height": 120,
                                "iconClass": "icon-common",
                                "bindingPath": "custom_item_print",
                                "iconPosition": "top"
                            }
                        ],
                        visibleWhen: 'custom_item=print'
                    },
                    {
                        type: 'Container',
                        children: [
                            {
                                "type": "Button",
                                "margin": "20px 50px",
                                "text": "Action 1",
                                "width": 120,
                                "height": 120,
                                "iconClass": "icon-common",
                                "bindingPath": "custom_item_action_1",
                                "iconPosition": "top"
                            }
                        ],
                        visibleWhen: 'custom_item=action_1'
                    },
                    {
                        type: 'Container',
                        children: [
                            {
                                "type": "Button",
                                "margin": "20px 50px",
                                "text": "Action 2",
                                "width": 120,
                                "height": 120,
                                "iconClass": "icon-common",
                                "bindingPath": "custom_item_action_2",
                                "iconPosition": "top"
                            }
                        ],
                        visibleWhen: 'custom_item=action_2'
                    }
                ]
            }
        ]
    });
}
